<template>
  <div class="selectSeriews_Box">
    <!-- 头部导航栏 -->
    <van-nav-bar>
      <template #left>
        <div @click="pageBack" style="display: flex; align-items: center">
          <van-icon name="arrow-left" size="18" />
          <span>{{$t("selectPage.previous.TR")}}</span>
        </div>
      </template>
      <template #title>
        <label>{{m_currentCatalogName}}</label>
      </template>
      <template #right>
        <div @click="toSelPumpList" style="display: flex; align-items: center">
          <span>{{$t("selectPage.nextStep.TR")}}</span>
          <van-icon name="arrow" size="18" />
        </div>
      </template>
    </van-nav-bar>
    <div class="selectSeriews_main">
      <van-row class="select_title_style" type="flex">
        <van-col
          span="6"
          @click="m_ShowBrandPicker = true"
        >
          <div :class="m_ShowBrandPicker?'brand-filter':''">
            <van-icon name="filter-o" />
            <span style="font-size:14px">品牌</span>
          </div>
        </van-col>
        <van-col
          v-if="m_setSeriesMethod.byCatalog.isVisible"
          class="select_btn"
          :class="m_selectIndex == 1 ? 'select_active' : ''"
          span="6"
          @click="selectMetchod(1)"
        >
          <span>{{$t("selectPage.byType.TR")}}</span>
        </van-col>
        <van-col
          v-if="m_setSeriesMethod.byHY.isVisible"
          @click="selectMetchod(2)"
          span="6"
          class="select_reveser_btn"
          :class="m_selectIndex == 2 ? 'select_active' : ''"
        >
          <span>{{$t("selectPage.byIndustry.TR")}}</span>
        </van-col>
        <van-col
          v-if="m_setSeriesMethod.byMedia.isVisible"
          @click="selectMetchod(3)"
          span="6"
          class="select_again_btn"
          :class="m_selectIndex == 3 ? 'select_active' : ''"
        >
          <span>{{$t("selectPage.byMedia.TR")}}</span>
        </van-col>
        <van-col span="6" style="position: absolute; right: 15px;" v-if="m_selectIndex == 1">
          <van-checkbox
            checked-color="#528abe"
            @change="changeSelectAllList"
            style="justify-content: center; font-size: 14px"
            v-model="m_SelectAllList"
          >{{ m_SelectAllList ? $t("selectPage.reselect.TR") : $t("selectPage.selectAll.TR") }}</van-checkbox>
        </van-col>
      </van-row>
      <!-- 按类型分类列表 -->
      <div class="select-series-continer" style="height: calc(100% - 42px); overflow: auto" v-if="m_selectIndex == 1">
          <van-cell
            v-for="(item, index) in m_VisibleSeriesList"
            clickable
            title-style="color:#808080"
            :key="item.ID"
            :label="item.CatalogName"
            @click="toggle(index)"
          >
           <template #title>
              <span style="font-weight: 700; font-size: 16px;">{{item.Name}}</span>
            </template>
           <template #value>
              <van-tag round type="primary" color="#528abe">{{item.CorpName}}</van-tag>
            </template>
            <template #icon>
              <van-image :src="item.ThumbnailImage" width="80" height="45" />
            </template>
            <template #right-icon>
              <van-checkbox
                v-model="item.isCheck"
                checked-color="#528abe"
                :name="item"
                @click="toggle(index)"
              />
            </template>
          </van-cell>
      </div>
      <!-- 按行业分类列表 -->
      <div clas style="height: calc(100% - 42px); overflow: auto" v-if="m_selectIndex == 2">
        <van-radio-group v-model="m_currentSelectHY">
          <van-cell-group>
            <van-cell
              v-for="hy_item in m_allHYList"
              :key="hy_item.ID"
              clickable
              @click="clickHYItem(hy_item)"
            >
              <template #title>
                <span style="color:#808080;margin-left:10px;">{{hy_item.NameCN}}</span>
              </template>
              <template #icon>
                <van-image :src="hy_item.ThumbnailImage" width="50" height="50" />
              </template>
              <template #right-icon>
                <van-radio :name="hy_item.ID" />
              </template>
            </van-cell>
          </van-cell-group>
        </van-radio-group>
      </div>
      <!-- 按介质分类列表 -->
      <div style="height: calc(100% - 42px); overflow: auto" v-if="m_selectIndex == 3">
        <van-radio-group v-model="m_currentSelectJZ">
          <van-cell-group>
            <van-cell
              v-for="(jz_item,jz_index) in m_allJZList"
              :key="jz_item.ID"
              clickable
              @click="clickJZItem(jz_item,jz_index)"
            >
              <template #title>
                <span style="color:#3d3d3d;margin-left:10px;font-size: 20px;">{{jz_item.NameCN}}</span>
              </template>
              <!-- <template #icon>
                <van-image :src="jz_item.ThumbnailImage" width="50" height="50" />
              </template>-->
              <template #right-icon>
                <van-radio :name="jz_item.ID" />
              </template>
            </van-cell>
          </van-cell-group>
        </van-radio-group>
      </div>
    </div>
      <!-- 品牌 -->
    <van-action-sheet v-model:show="m_ShowBrandPicker" title="品牌选择">
      <div class="brand-content">
        <!-- <div class="brand-item" @click="onChangeBrandSelectAll" :class="brandSelectAll?'brand-item-active':''">
          <span>全部</span>
        </div> -->
        <div class="brand-item" @click="onChangeBrandSelect(brand_item,brand_index)" :class="brand_item.isSelect?'brand-item-active':''" v-for="(brand_item,brand_index) in m_allBrandList" :key="brand_index">
          <span>{{brand_item.name}}</span>
        </div>
      </div>
    </van-action-sheet>
    <transition name="van-slide-left">
      <div class="poptips" v-show="showPopover">{{$t('selectPage.seriesRangTips.TR')}}</div>
    </transition>
  </div>
</template>

<script>
import Utils from "../../utils/utils";
import axiosHelper from "@/utils/axiosHelper.js";
import languageMixin from "@/mixin/language.js";

export default {
  name:"SelSeries",
  mixins: [languageMixin],
  data() {
    return {
      m_userType:0,
      m_userID:0,
      m_pumpCategoryID:"",//泵型ID
      m_pageTitle: "",
      m_currentCatalogName:"",//当前类型的名称
      m_SeriesList: [], //原始系列列表

      m_currentSelectHY: "", //当前选中的行业
      m_allHYList: [], //所有行业列表

      m_currentSelectJZ: "",
      m_allJZList: [], //所有介质列表
      m_allBrandList:[],//当前所有品牌
      brandSelectAll:false,//是否选择所有品牌
      m_VisibleSeriesList: [], //用于页面展示的系列列表

      m_prevPageData: {}, //上个页面传入的数据
      m_selectIndex: 1, //列表的选择状态 1表示按类型 2表示按行业 3表示按介质
      m_SelectSeriesID: [], //储存选择的系列的id
      m_pinlv: "", //电机频率
      m_SelectAllList: false,
      m_ShowBrandPicker:false,//显示品牌选择弹框
      m_setSeriesMethod: {
        byCatalog: {
          isDisable: true,
          isVisible: false
        },
        byHY: {
          isDisable: true,
          isVisible: false
        },
        byMedia: {
          isDisable: true,
          isVisible: false
        }
      },
      showPopover: false
    };
  },
    activated() {
        // keepalive缓存的页面每次进入都会进行的生命周期
        console.log("keepalive缓存的页面每次进入都会进行的生命周期")
    },
  mounted() {
    let _this = this;    
    let userType = this.$store.state.instante.account.UserType;
    let userID = this.$store.state.instante.account.UserID;
    this.m_userType = userType;
    this.m_userID = userID;
    this.m_pageTitle =  this.getSoftName();
    document.title = this.m_pageTitle
    this.m_currentCatalogName = this.$route.query.catalogName
    let prvePathDataObj = this.$store.state.instante.select.ByParas.filterData;
    // console.log(prvePathDataObj,198)
    if (prvePathDataObj) {
      this.m_prevPageData = prvePathDataObj;
      this.m_pinlv = prvePathDataObj.FilterInfo.MotorFrequence;
      this.m_pumpCategoryID = prvePathDataObj.FilterInfo.CatalogID
      if (prvePathDataObj.FilterInfo.SeriesID) {
        //console.log(prvePathDataObj.FilterInfo.SeriesID,104)
        this.m_SelectSeriesID = prvePathDataObj.FilterInfo.SeriesID.split(",");
      }
    }
    if (this.m_SelectSeriesID.length == 0) {
      _this.showPopover = true;
      setTimeout(function() {
        _this.showPopover = false;
      }, 3000);
    } else {
      _this.showPopover = false;
    }

    //console.log(this.m_SelectSeriesID, 34);
    this.getParaPageInfo();
    // this.buildHYList();
    this.buildJZList();
    setTimeout(function() {
      //判断如果行业和介质都不显示 就隐藏整个分类选择
      if (
        _this.m_setSeriesMethod.byHY.isVisible == false &&
        _this.m_setSeriesMethod.byMedia.isVisible == false
      ) {
        _this.m_setSeriesMethod.byCatalog.isVisible = false;
      }
    }, 500);
  },
  methods: {
    getParaPageInfo() {
      let _this = this;
      let myToast = _this.$toast;
      myToast.loading({
        duration: 0, //为0时 不关闭toast框
        message: "Loading...",
        forbidClick: true
      });
      _this
        .$axios({
          url:
            _this.$globalConfig.WebApiUrl.MainUrl +
            "/v1/Mobile/PumpSeries/GetListByCategoryID",
            params:{
              Lang:_this.getCurrentLanguageType(),
              CategoryID:_this.m_pumpCategoryID
            }
        }) 
        .then(res => {
          //  console.log(res);
          let result = res.data;
          if (result.Code != 0) {
            myToast.clear();
            myToast.fail({
              duration: 1000, //为0时 不关闭toast框
              message: "未找到相关系列...",
              forbidClick: true
            });
            return;
          }
          if (result.Data) {
            myToast.clear();
            let brandList = []
            let seriesList = result.Data;
            seriesList.forEach(element => {
              element.isCheck = false;
            let brandObj = {
              name:element.CorpName,
              isSelect:false
            }
             brandList.push(brandObj)
            });
            _this.m_SeriesList = seriesList;
            _this.m_allBrandList = _this.uniqueCorpList(brandList)
            // console.log(_this.m_allBrandList,287)
            if (_this.m_SelectSeriesID) {
              _this.m_SelectSeriesID.forEach(item => {
                _this.m_SeriesList.forEach(seriesItem => {
                  if (item == seriesItem.ID) {
                    seriesItem.isCheck = true;
                  }
                });
              });
            }
            if (_this.m_SelectSeriesID.length == _this.m_SeriesList.length) {
              _this.m_SelectAllList = true;
            }

            _this.filterSeriesList(
              _this.m_SeriesList,
              _this.m_pinlv
            );
          }
        })
        .catch(err => {
          console.log(err);
        });
    },
    //构建行业列表
    // buildHYList() {
    //   if (
    //     window.seriesApplication.HangYe == "undefind" ||
    //     window.seriesApplication.HangYe == null
    //   ) {
    //     window.seriesApplication.HangYe = {};
    //   }
    //   let HYData = window.seriesApplication.HangYe.List;
    //   if (HYData == null || HYData.length == 0) {
    //     this.m_allHYList = [];
    //   } else {
    //     this.m_setSeriesMethod.byHY.isVisible = true;
    //     HYData.forEach(item => {
    //       item.ThumbnailImage = require("../../assets/img/HangYe/" +
    //         item.ImageName +
    //         "/ffffffx128.png");
    //     });
    //     this.m_allHYList = HYData;
    //   }
    // },
    //构建介质列表
    buildJZList() {
      if (
        window.seriesApplication.JieZhiParas == "undefind" ||
        window.seriesApplication.JieZhiParas == null
      ) {
        window.seriesApplication.JieZhiParas = {};
      }
      let JZData = window.seriesApplication.JieZhiParas.List;
      if (JZData == null || JZData.length == 0) {
        this.m_allJZList = [];
      } else {
        this.m_setSeriesMethod.byMedia.isVisible = true;
        // JZData.forEach(item => {
        //   item.ThumbnailImage = require("../../assets/img/HangYe/" +
        //     item.ImageName +
        //     "/ffffffx128.png");
        // });
        this.m_allJZList = JZData;
      }
      // console.log(this.m_setSeriesMethod.byMedia.isVisible);
    },
    //系列列表筛选方法
    filterSeriesList(seriesList, MotorFrequece) {
      let motorFrequece = MotorFrequece;
      let showSeriesList = [];

      seriesList.forEach(node => {
        if (node.MotorFrequece == motorFrequece) {
          showSeriesList.push(node);
        }
      });
      // console.log(showSeriesList,365) 
      this.m_VisibleSeriesList = showSeriesList;
      // console.log(this.m_VisibleSeriesList,186)
    },
    //按类型多选 checkbox 选择状态切换
    toggle(index) {
      this.m_VisibleSeriesList[index].isCheck = !this.m_VisibleSeriesList[index].isCheck;
      let ser_id = [];
      this.m_VisibleSeriesList.forEach(ser_item => {
        if (ser_item.isCheck) {
          ser_id.push(ser_item.ID);
        }
      });
      this.m_SelectSeriesID = ser_id;
    },
    //按行业选择
    clickHYItem(item) {
      this.m_currentSelectHY = item.ID;
      let ser_id = [];
      if (item.PumpSeriesID.length == 0) {
        return;
      }
      ser_id.push(...item.PumpSeriesID);
      if (ser_id.length > 0) this.m_SelectSeriesID = ser_id;
    },
    //按介质选择
    clickJZItem(item, index) {
      this.m_currentSelectJZ = item.ID;
      let ser_id = [];
      let all_id = [];
      let jzData = this.m_allJZList;
      if (item.PumpSeriesID.length == 0) {
        return;
      }
      if (item.PumpSeriesID.length == 1 && item.PumpSeriesID[0] == -1) {
        jzData.forEach(jz_item => {
          all_id.push(...jz_item.PumpSeriesID);
        });
        ser_id = all_id.splice(0, all_id.length - 1);
        if (ser_id.length > 0) this.m_SelectSeriesID = ser_id;
        return;
      }
      ser_id.push(...item.PumpSeriesID);
      if (ser_id.length > 0) this.m_SelectSeriesID = ser_id;
    },
    //全选
    selectMetchod(index) {
      this.m_selectIndex = index;
      this.m_SelectSeriesID = [];
    },
    //反选
    selectReveres(index) {
      this.m_selectIndex = index;
      let SeriesID = [];
      if (this.m_SelectSeriesID.length == 0) {
        this.m_SeriesList.forEach(node => {
          node.isCheck = !node.isCheck;
          SeriesID.push(node.ID);
        });
        this.m_SelectSeriesID = SeriesID;
      } else {
        this.m_SeriesList.forEach(node => {
          node.isCheck = !node.isCheck;
        });
        this.m_SelectSeriesID = [];
      }
    },
    //监听全选和取消全选
    changeSelectAllList(val) {
      let SeriesID = [];
      if (val) {
        this.m_VisibleSeriesList.forEach(node => {
          node.isCheck = true;
          SeriesID.push(node.ID);
        });
        this.m_SelectSeriesID = SeriesID;
      } else {
        this.m_VisibleSeriesList.forEach(node => {
          node.isCheck = false;
        });
        this.m_SelectSeriesID = [];
      }
    },
    //返回上一页
    pageBack() {
      this.$router.go(-1);
    },
    //跳转到泵详情界面
    toSelPumpList() {
      if (this.m_SelectSeriesID.length == 0) {
        let Toast = this.$toast;
        if (this.m_selectIndex == 1) {
          Toast.fail({
            duration: 1000, //为0时 不关闭toast框
            message: `${this.$t('selectPage.seriesRule.TR')}`,
            forbidClick: true
          });
          return;
        }
        if (this.m_selectIndex == 2) {
          Toast.fail({
            duration: 1000, //为0时 不关闭toast框
            message: `${this.$t('selectPage.hangyeRule.TR')}`,
            forbidClick: true
          });
          return;
        }
        if (this.m_selectIndex == 3) {
          Toast.fail({
            duration: 1000, //为0时 不关闭toast框
            message: `${this.$t('selectPage.jiezhiRule.TR')}`,
            forbidClick: true
          });
          return;
        }
      }
      let groupPageData = {
        //页面其他展示数据
        //介质
        JieZhi: {
          ID: this.m_prevPageData.JieZhi.ID, //介质id
          Name: this.m_prevPageData.JieZhi.ID, //介质名称
          CalcDensity: this.m_prevPageData.JieZhi.CalcDensity, //密度
          CalcViscosity: this.m_prevPageData.JieZhi.CalcViscosity //粘度
        },
        //筛选信息
        FilterInfo: {
          DriveType: this.m_prevPageData.FilterInfo.DriveType, //设备类型 0电机 3柴油机
          KeyWord: this.m_prevPageData.FilterInfo.KeyWord, //关键字 暂时默认空
          FirePumpType: this.m_prevPageData.FilterInfo.FirePumpType, //消防泵类型
          MotorPoleNum: this.m_prevPageData.FilterInfo.MotorPoleNum, //电机效率等级 暂时为空
          DieselSpeed: this.m_prevPageData.FilterInfo.DieselSpeed, //柴油机转速 暂时默认
          MotorFrequence: this.m_prevPageData.FilterInfo.MotorFrequence, //电机赫兹
          Temperature: this.m_prevPageData.FilterInfo.Temperature, //温度
          MotorStandard: this.m_prevPageData.FilterInfo.MotorStandard, //电机功率标准
          SeriesSelectMethod: 0, //0 用的是 CatalogID   1 用的是SeriesID      2 行业
          SeriesID: this.m_SelectSeriesID.join(","), //泵系列ID 暂时默认为空
          CatalogID: this.m_pumpCategoryID //泵类型id
        },
        //设计点参数
        DesignInfo: {
          UnitQ: this.m_prevPageData.DesignInfo.UnitQ, //流量单位
          UnitH: this.m_prevPageData.DesignInfo.UnitH, //扬程单位
          DpQ: this.m_prevPageData.DesignInfo.DpQ, //输入的流量的值
          DpH: this.m_prevPageData.DesignInfo.DpH, //输入的扬程的值
          ToleranceStandard:this.m_prevPageData.DesignInfo.ToleranceStandard,//容差标准的值
          PointTolerance: this.m_prevPageData.DesignInfo.PointTolerance, // 点容差范围 默认空
          IsVisCorrect: this.m_prevPageData.DesignInfo.IsVisCorrect //是否修正粘度 默认false
        }
      };
      console.log(groupPageData,497)
      //将筛选数据存储到vuex中
      this.$store.commit("instante/select/ByParas", {
        //select 表示vuex的文件名
        filterData: groupPageData
      });
    this.gotoPage("/Select/PumpList", "", null);
      //console.log(groupPageData);
      //console.log(this.m_SelectSeriesID);
    },
    // 全选
    onChangeBrandSelectAll(){
      this.brandSelectAll = !this.brandSelectAll
      let currentBrandSelectArr= []
      let currentBrandSelectName = []
      this.m_BrandColumns.forEach(item=>{
        if(this.brandSelectAll){
          item.IsSelect = true
        }else {
          item.IsSelect = false
        }

        if(item.IsSelect){
         currentBrandSelectArr.push(item.ID)
         currentBrandSelectName.push(item.ShortName)
        }
      })

      this.m_BrandShowValue = currentBrandSelectName.join(',')
      this.m_BrandValue = currentBrandSelectArr
    },
    //监听品牌选择
    onChangeBrandSelect(e,index){
       this.m_allBrandList[index].isSelect = !this.m_allBrandList[index].isSelect
       let showSeriesList = [];
      let currentSelectBrand = []
          this.m_allBrandList.forEach(item=>{
            if(item.isSelect){
              currentSelectBrand.push(item.name)
            }
          })
          if(currentSelectBrand.length == 0){
           this.filterSeriesList(
              this.m_SeriesList,
              this.m_pinlv
            );
            return
          }
          currentSelectBrand.forEach(brand=>{
           this.m_SeriesList.forEach(series_item=>{
            if(brand == series_item.CorpName){
              showSeriesList.push(series_item)
            }
          })
        })
      // console.log(showSeriesList,568)
         this.filterSeriesList(
              showSeriesList,
              this.m_pinlv
            );
    },
    //公司筛选列表去重
  uniqueCorpList (arr) {
    let map = new Map();
    for (let item of arr) {
        if (!map.has(item.name)) {
            map.set(item.name, item);
        }
    }
    return [...map.values()];
    }
  }
};
</script>

<style lang="scss">
.selectSeriews_Box {
  width: 100%;
  height: 100vh;
  .select_title_style {
    height: 42px;
    align-items: center;
    background: #ffffff;
    padding: 0 10px;
    justify-content: start;
    position: relative;
    box-shadow:0px 15px 10px -15px #000;
  }
  .selectSeriews_main {
    width: 100%;
    height: calc(100% - 47px);
    background-color: #fafafa;
    .van-button--primary {
      color: #000;
      background-color: unset;
      border: unset;
    }
    .van-cell-group__title {
      padding: 5px 16px 5px;
      text-align: left;
      background: #528abe;
      font-weight: 600;
      color: #ffffff;
    }
    .van-cell__title,
    .van-cell__value {
      text-align: left;
      font-size: 13px;
    }
    .van-cell__label{
      width:180px;
    }
    .van-collapse-item__content {
      padding: 0px 16px;
    }
    .van-field__label {
      width: 7em;
    }
    .select_btn {
      border: 1px solid #eeeeee;
      font-size: 14px;
      padding: 3px 0px;
    }
    .select_again_btn {
      border-bottom: 1px solid #eeeeee;
      border-top: 1px solid #eeeeee;
      border-right: 1px solid #eeeeee;
      font-size: 14px;
      padding: 3px 0px;
      span {
        color: #000000;
      }
    }
    .select_reveser_btn {
      border-bottom: 1px solid #eeeeee;
      border-top: 1px solid #eeeeee;
      border-right: 1px solid #eeeeee;

      font-size: 14px;
      padding: 3px 0px;
      span {
        color: #000000;
      }
    }
    .select_active {
      background: #528abe;
      span {
        color: #fff;
      }
    }
    .select-series-continer{
      .van-tag{
          position: absolute;
          top: 3px;
          right: 15px;
      }
    }
  }
  .brand-filter{
    i,span{
      color: #578ebe;
    }
  }
    .brand-content {
      height: 40vh;
      padding: 0px 5px;
      display: flex;
      flex-wrap: wrap;
      justify-content: flex-start;
      align-content: flex-start;
      overflow: auto;
    }
    .brand-item {
      display: flex;
      flex-direction: column;
      width: 120px;
      height: 32px;
      justify-content: center;
      align-items: center;
      background-color: #f1f2f3;
      border-radius: 20px;
      margin-bottom: 10px;
      margin-right: 5px;
      box-sizing: border-box;
        span{
          font-size: 12px;
        }
    }
    .brand-item-active{
      border: 1px solid #578ebe;
      background-color: #ecf5ff;
      span{
        font-size: 12px;
        color:#578ebe
      }
    }
  .poptips {
    // width: 135px;
    height: 18px;
    position: fixed;
    top: 32px;
    left: 10px;
    background-color: #000;
    color: #ffffff;
    z-index: 1;
    font-size: 12px;
    text-align: center;
    border-radius: 3px;
  }
}
</style>